searchNodes=[{"doc":"Xfile contains augmentations of the built-in File module, such as supporting streams, recursion, and programmatic filtering.","ref":"Xfile.html","title":"Xfile","type":"module"},{"doc":"As Xfile.ls/2 , but returns raw results on success or raises on :error .","ref":"Xfile.html#ls!/2","title":"Xfile.ls!/2","type":"function"},{"doc":"Like File.ls/1 , this returns the list of files in the given directory, but it makes available some useful options to support recursive listing and filtering results programmatically. Stream Unlike File.ls/1 , Xfile.ls/2 returns its result as a Stream , so you must remember to convert it to a list via Enum.to_list/1 if you are not lazily evaluating its result. Options :recursive indicates whether the directory and its subdirectories should be recursively searched. This can be expressed either as a simple boolean or as a positive integer indicating the maximum depth (where false is equivalent to 0 and would list only the contents of the given directory). Default: true :filter can be either a regular expression to be used with String.match?/2 OR an arity 1 function that receives the full file path and returns a boolean value. If the filter operation returns true , the file will be included in the output. Any other output will cause the file to be filtered from the output. Optional. Examples Use a regular expression to return only .txt files: iex&gt; { :ok , stream } = Xfile . ls ( &quot;path/to/files&quot; , filter : ~r/ \\. txt$/ ) { :ok , # Function &lt; 59.58486609 / 2 in Stream . transform / 3 &gt; } iex&gt; Enum . to_list ( stream ) [ &quot;path/to/files/a.txt&quot; , &quot;path/to/files/b.txt&quot; , &quot;path/to/files/subdir/c.txt&quot; ] Use a function to apply more complex logic to filter the results: iex&gt; { :ok , stream } = Xfile . ls ( &quot;mydir&quot; , filter : fn x -&gt; stat = File . stat! ( x ) stat . size &gt; 1024 end ) { :ok , # Function &lt; 59.58486609 / 2 in Stream . transform / 3 &gt; } iex&gt; Enum . to_list ( stream ) [ &quot;mydir/big-file&quot; , &quot;mydir/big-file2&quot; , # ... ] Limit the depth of the recursion to the given directory and its subdirectories, but no further: iex&gt; { :ok , stream } = Xfile . ls ( &quot;top/dir&quot; , recursive : 1 ) { :ok , # Function &lt; 59.58486609 / 2 in Stream . transform / 3 &gt; } iex&gt; Enum . to_list ( stream ) [ &quot;top/dir/a&quot; , &quot;top/dir/b&quot; , # ... &quot;top/dir/sub1/x&quot; , &quot;top/dir/sub1/y&quot; ]","ref":"Xfile.html#ls/2","title":"Xfile.ls/2","type":"function"},{"doc":"Xfile is a utility module providing augmentations to the functions in the built-in File module, specifically adding useful functionality to the ls function.","ref":"readme.html","title":"Xfile","type":"extras"},{"doc":"Use a regular expression to return only .txt files: iex&gt; { :ok , stream } = Xfile . ls ( &quot;path/to/files&quot; , filter : ~r/ \\\\ .txt$/ ) { :ok , # Function &lt; 59.58486609 / 2 in Stream . transform / 3 &gt; } iex&gt; Enum . to_list ( stream ) [ &quot;path/to/files/a.txt&quot; , &quot;path/to/files/b.txt&quot; , &quot;path/to/files/subdir/c.txt&quot; ] Use a function to apply more complex logic to filter the results: iex&gt; { :ok , stream } = Xfile . ls ( &quot;mydir&quot; , filter : fn x -&gt; stat = File . stat! ( x ) stat . size &gt; 1024 end ) { :ok , # Function &lt; 59.58486609 / 2 in Stream . transform / 3 &gt; } iex&gt; Enum . to_list ( stream ) [ &quot;mydir/big-file&quot; , &quot;mydir/big-file2&quot; , # ... ] Limit the depth of the recursion to the given directory and its subdirectories, but no further: iex&gt; { :ok , stream } = Xfile . ls ( &quot;top/dir&quot; , recursive : 1 ) { :ok , # Function &lt; 59.58486609 / 2 in Stream . transform / 3 &gt; } iex&gt; Enum . to_list ( stream ) [ &quot;top/dir/a&quot; , &quot;top/dir/b&quot; , # ... &quot;top/dir/sub1/x&quot; , &quot;top/dir/sub1/y&quot; ]","ref":"readme.html#examples","title":"Xfile - Examples","type":"extras"},{"doc":"If available in Hex , the package can be installed by adding xfile to your list of dependencies in mix.exs : def deps do [ { :xfile , &quot;~&gt; 0.1.0&quot; } ] end Documentation can be generated with ExDoc and published on HexDocs . Once published, the docs can be found at https://hexdocs.pm/xfile .","ref":"readme.html#installation","title":"Xfile - Installation","type":"extras"},{"doc":"Alien by Martin Smith from NounProject.com","ref":"readme.html#image-attribution","title":"Xfile - Image Attribution","type":"extras"},{"doc":"The format is based on Keep a Changelog , and this project adheres to Semantic Versioning .","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Initial release.","ref":"changelog.html#v0-1-0","title":"Changelog - v0.1.0","type":"extras"}]